!H!****************************************************************************
!H! File: ../fpt_output/WRFV3/external/fpt_lib/rt_trace.f90
!H! Output by FPT 3.7-u Intel-Linux   On  9-JUN-13  At 15:47:57    Input files:
!H! Main:    ...pt2/WRF/WRFV3.3/compiler_validation/fpt/WRFV3.3_raw_raw_rtt.fpp
!H! Current: /usr/local/fpt/fpt37/fpt_lib/rt_trace.for
!H! Licensee:  SimCon: Development version.
!H!****************************************************************************
! *****************************************************************************
! RT_TRACE.FOR			14-Jan-99			John Collins
!				26-Oct-12			John Collins
!
! Run-time trace subroutines
!
! *****************************************************************************
! 26-Apr-04 John Collins  SPR 735 - Addition of sequence number
! 22-Feb-06 John Collins  Fixed format for comparison between hosts
! 21-Apr-10 John Collins  All real formats changed & standardised
!  3-Jun-10 John Collins  Event numbers
! 24-Aug-12 John Collins  STOP after irrecoverable errors
! 24-Aug-12 John Collins  Trace data suppressed in check mode
!  3-Oct-12 John Collins  CHARACTER values not stored in trace mode
! 26-Oct-12 John Collins  Option not to overwrite integers & logicals
! *****************************************************************************
!
BLOCK DATA fpt_rt_trace_data
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        DATA c_directory_length/0/
        DATA trace_file_open_flag/.FALSE./
        DATA trace_active_flag/.TRUE./
        DATA c_rt_trace_check_f/.FALSE./
        DATA c_trace_event/0/
!
        DATA c_real_delta/0.0001D0/
        DATA c_real_ratio/0.01D0/
        DATA c_overwrite_integers_f/.TRUE./
        DATA c_overwrite_logicals_f/.TRUE./
!
END 	    ! fpt_rt_trace_data ***********************************************
!
! *****************************************************************************
!
SUBROUTINE trace_start_sub_program(stra,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! Sub-program name
        INTEGER*4 sequa
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        CHARACTER*24 sequs
        CHARACTER*31 spnm
!
! *****************************************************************************
!
        spnm = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ELSEIF (spnm .NE. c_trace_sp_name) THEN
                 CALL fpt_rt_trace_sp_error(spnm)
              ENDIF
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (p_trace_lun,'(/,A,''   Start sub-program: '',A)')                                                             &
               sequs,stra(1:MIN(LEN(stra),31))
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_start_sub_program *****************************************
!
! *****************************************************************************
!
SUBROUTINE trace_return_sub_program(stra,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! Sub-program name
        INTEGER*4 sequa
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        CHARACTER*24 sequs
        CHARACTER*31 spnm
!
! *****************************************************************************
!
        spnm = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ELSEIF (spnm .NE. c_trace_sp_name) THEN
                 CALL fpt_rt_trace_sp_error(spnm)
              ENDIF
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (p_trace_lun,'(A,''   Return: '',A,/)')                                                                        &
               sequs,stra(1:MIN(LEN(stra),31))
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_return_sub_program ****************************************
!
! *****************************************************************************
!
SUBROUTINE trace_l1_data(stra,l1a,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        LOGICAL*1 l1a			! 1 byte logical ...
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*24 sequs
        CHARACTER*50 str
        CHARACTER*1 l1s
        LOGICAL*1 l1
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        str = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),*,ERR = 1010)l1
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input,'(L1)')l1a
              CALL fpt_rt_trace_read_error
              l1 = l1a
1020          CONTINUE
              IF (l1 .NEQV. l1a) THEN
                 WRITE (c_trace_input,'(L1)')l1a
                 CALL fpt_rt_trace_value_error
                 IF (c_overwrite_logicals_f) THEN
                    l1a = l1
                 ENDIF
              ENDIF
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (l1s,'(L1)')l1a
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',l1s
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_l1_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE trace_l2_data(stra,l2a,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        LOGICAL*2 l2a			!
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
        CHARACTER*1 l2s
        LOGICAL*2 l2
!
! *****************************************************************************
!
        str = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),*,ERR = 1010)l2
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input,'(L1)')l2a
              CALL fpt_rt_trace_read_error
              l2 = l2a
1020          CONTINUE
              IF (l2 .NEQV. l2a) THEN
                 WRITE (c_trace_input,'(L1)')l2a
                 CALL fpt_rt_trace_value_error
                 IF (c_overwrite_logicals_f) THEN
                    l2a = l2
                 ENDIF
              ENDIF
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (l2s,'(L1)')l2a
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',l2s
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_l2_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE trace_l4_data(stra,l4a,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        LOGICAL*4 l4a			!
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
        CHARACTER*1 l4s
        LOGICAL*4 l4
!
! *****************************************************************************
!
        str = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),*,ERR = 1010)l4
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input,'(L1)')l4a
              CALL fpt_rt_trace_read_error
              l4 = l4a
1020          CONTINUE
              IF (l4 .NEQV. l4a) THEN
                 WRITE (c_trace_input,'(L1)')l4a
                 CALL fpt_rt_trace_value_error
                 IF (c_overwrite_logicals_f) THEN
                    l4a = l4
                 ENDIF
              ENDIF
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (l4s,'(L1)')l4a
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',l4s
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_l4_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE trace_i1_data(stra,i1a,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        INTEGER*1 i1a			! 1 byte logical ...
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
        CHARACTER*12 i1s
        INTEGER*1 i1
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        str = stra
!
        c_trace_event = c_trace_event+1
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),'(I12)',ERR = 1010)i1
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input,'(I12)')i1a
              CALL fpt_rt_trace_read_error
              i1 = i1a
1020          CONTINUE
              IF (i1 .NE. i1a) THEN
                 WRITE (c_trace_input,'(I12)')i1a
                 CALL fpt_rt_trace_value_error
                 IF (c_overwrite_integers_f) THEN
                    i1a = i1
                 ENDIF
              ENDIF
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (i1s,'(I12)')i1a
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',i1s
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_i1_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE trace_i2_data(stra,i2a,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        INTEGER*2 i2a			!
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
        CHARACTER*12 i2s
        INTEGER*2 i2
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        str = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),'(I12)',ERR = 1010)i2
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input,'(I12)')i2a
              CALL fpt_rt_trace_read_error
              i2 = i2a
1020          CONTINUE
              IF (i2 .NE. i2a) THEN
                 WRITE (c_trace_input,'(I12)')i2a
                 CALL fpt_rt_trace_value_error
                 IF (c_overwrite_integers_f) THEN
                    i2a = i2
                 ENDIF
              ENDIF
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (i2s,'(I12)')i2a
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',i2s
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_i2_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE trace_i4_data(stra,i4a,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        INTEGER*4 i4a			!
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
        CHARACTER*12 i4s
        INTEGER*4 i4
!
! *****************************************************************************
!
        str = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),'(I12)',ERR = 1010)i4
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input,'(I12)')i4a
              CALL fpt_rt_trace_read_error
              i4 = i4a
1020          CONTINUE
              IF (i4 .NE. i4a) THEN
                 WRITE (c_trace_input,'(I12)')i4a
                 CALL fpt_rt_trace_value_error
                 IF (c_overwrite_integers_f) THEN
                    i4a = i4
                 ENDIF
              ENDIF
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (i4s,'(I12)')i4a
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',i4s
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_i4_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE trace_r4_data(stra,r4a,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        REAL*4 r4a			!
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
        CHARACTER*24 r4s
        REAL*4 r4
!
! *****************************************************************************
!
        str = stra
!
        c_trace_event = c_trace_event+1
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),'(E24.15)',ERR = 1010)r4
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input,'(E24.15)')r4a
              CALL fpt_rt_trace_read_error
              r4 = r4a
1020          CONTINUE
              IF (ABS(r4-r4a) .GT. SNGL(c_real_delta)) THEN
                 IF (ABS(r4) .GT. SNGL(c_real_delta)) THEN
!%                  DO NOT PROTECT AGAINST DIVISION BY ZERO
                    IF (ABS((r4-r4a)/r4) .LT. SNGL(c_real_ratio)) THEN
                       GOTO 3010
                    ENDIF
                 ENDIF
                 WRITE (c_trace_input,'(E24.15)')r4a
                 CALL fpt_rt_trace_value_error
3010             CONTINUE
              ENDIF
              r4a = r4
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (r4s,'(E24.15)')r4a
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',r4s
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_r4_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE trace_r8_data(stra,r8a,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        REAL*8 r8a			!
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
        CHARACTER*24 r8s
        REAL*8 r8
!
! *****************************************************************************
!
        str = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),'(E24.15)',ERR = 1010)r8
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input,'(E24.15)')r8a
              CALL fpt_rt_trace_read_error
              r8 = r8a
1020          CONTINUE
              IF (ABS(r8-r8a) .GT. c_real_delta) THEN
                 IF (ABS(r8) .GT. c_real_delta) THEN
!%                  DO NOT PROTECT AGAINST DIVISION BY ZERO
                    IF (ABS((r8-r8a)/r8) .LT. c_real_ratio) THEN
                       GOTO 3010
                    ENDIF
                 ENDIF
                 WRITE (c_trace_input,'(E24.15)')r8a
                 CALL fpt_rt_trace_value_error
3010             CONTINUE
              ENDIF
              r8a = r8
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (r8s,'(E24.15)')r8a
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',r8s
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_r8_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE trace_x8_data(stra,x8a,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        COMPLEX*8 x8a			!
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
        CHARACTER*51 x8s
!
!       Note that we cannot use the intrinsic REAL because it is ambiguous
!       in g77.  Therefore we equivalence the complex number to reals
        COMPLEX*8 x8t,x8c
        REAL*4 rx8(2,2)
        EQUIVALENCE (x8c,rx8(1,1))
        EQUIVALENCE (x8t,rx8(1,2))
!
        INTEGER*4 i
!
! *****************************************************************************
!
        str = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),'(2(1X,E24.15))'                                                                 &
               ,ERR = 1010)x8t
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input                                                                                                 &
               ,'(''('',E24.15,'','',E24.15,'')'')')x8a
              CALL fpt_rt_trace_read_error
              x8t = x8a
1020          CONTINUE
              x8c = x8a
              DO i = 1,2
                 IF (ABS(rx8(i,1)-rx8(i,2)) .GT. SNGL(c_real_delta)) THEN
                    IF (ABS(rx8(i,2)) .GT. SNGL(c_real_delta)) THEN
!%                     DO NOT PROTECT AGAINST DIVISION BY ZERO
                       IF (ABS((rx8(i,1)-rx8(i,2))/rx8(i,2)) .LT. SNGL(                                                            &
                        c_real_ratio)) THEN
                          GOTO 4010
                       ENDIF
                    ENDIF
                    WRITE (c_trace_input                                                                                           &
                     ,'(''('',E24.15,'','',E24.15,'')'')')x8a
                    CALL fpt_rt_trace_value_error
                    GOTO 4020
4010                CONTINUE
                 ENDIF
              ENDDO
4020          CONTINUE
              x8a = x8t
           ELSE
              WRITE (sequs,'(I12)')sequa
              WRITE (x8s,'(''('',1E24.15,'','',1E24.15,'')'')')x8a
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',x8s
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_x8_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE trace_x16_data(stra,xha,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        COMPLEX*16 xha			!
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
        CHARACTER*51 xhs
!
!       Note that we cannot use the intrinsic REAL because it is ambiguous
!       in g77.  Therefore we equivalence the complex number to reals
        COMPLEX*16 xht,xhc
        REAL*8 rxh(2,2)
        EQUIVALENCE (xhc,rxh(1,1))
        EQUIVALENCE (xht,rxh(1,2))
!
        INTEGER*4 i
!
!
! *****************************************************************************
!
        str = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),'(2(1X,E24.15))'                                                                 &
               ,ERR = 1010)xht
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input                                                                                                 &
               ,'(''('',E24.15,'','',E24.15,'')'')')xha
              CALL fpt_rt_trace_read_error
              xht = xha
1020          CONTINUE
              xhc = xha
              DO i = 1,2
                 IF (ABS(rxh(i,1)-rxh(i,2)) .GT. c_real_delta) THEN
                    IF (ABS(rxh(i,2)) .GT. c_real_delta) THEN
!%                     DO NOT PROTECT AGAINST DIVISION BY ZERO
                       IF (ABS((rxh(i,1)-rxh(i,2))/rxh(i,2)) .LT.                                                                  &
                        c_real_ratio) THEN
                          GOTO 5010
                       ENDIF
                    ENDIF
                    WRITE (c_trace_input                                                                                           &
                     ,'(''('',E24.15,'','',E24.15,'')'')')xha
                    CALL fpt_rt_trace_value_error
                    GOTO 5020
5010                CONTINUE
                 ENDIF
              ENDDO
5020          CONTINUE
              xha = xht
           ELSE
              WRITE (sequs,'(I12)')sequa
              WRITE (xhs,'(''('',1E24.15,'','',1E24.15,'')'')')xha
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',xhs
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_x16_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE trace_ch_data(stra,cha,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
!       Arguments
!       =========
!
        CHARACTER*(*)stra		! String describing object written
        CHARACTER*(*)cha		!
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
!
! *****************************************************************************
!
        str = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
        ENDIF
!
        c_trace_event = c_trace_event+1
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
!             Note that character variables may contain <CR>, <LF> etc which
!             are read as spurious new-lines in check mode and cause errors
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'='                                                                        &
               ,' string (Not recorded)'
!!!  1       ,cha(1:(MIN(LEN(cha),64)))
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_ch_data ***************************************************
!
! *****************************************************************************
!
SUBROUTINE fpt_open_rt_trace_file
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        CHARACTER*128 trace_input_file_name
        CHARACTER*128 trace_file_name
!
! *****************************************************************************
!
        CALL fpt_rt_trace_controls
!
        IF (c_directory_length .GT. 0) THEN
           trace_input_file_name = c_trace_directory(1:c_directory_length)                                                         &
            //p_trace_input_file_name
           trace_file_name = c_trace_directory(1:c_directory_length)                                                               &
            //p_trace_file_name
        ELSE
           trace_input_file_name = p_trace_input_file_name
           trace_file_name = p_trace_file_name
        ENDIF
!
        INQUIRE (FILE = trace_input_file_name,EXIST = c_rt_trace_check_f)
        IF (c_rt_trace_check_f) THEN
           OPEN (UNIT = p_trace_input_lun,STATUS = 'OLD'                                                                           &
            ,FILE = trace_input_file_name,ERR = 8000)
           WRITE (6,'(/,''RT_TRACE - Running in check mode'',/)')
        ENDIF
        OPEN (UNIT = p_trace_lun,STATUS = 'UNKNOWN'                                                                                &
         ,FILE = trace_file_name,ERR = 8010)
        trace_file_open_flag = .TRUE.
!
        RETURN
!
8000    CONTINUE
        STOP 'FPT - RT Trace Check - Failed to open trace input file'
!
8010    CONTINUE
        STOP 'FPT - RT Trace - Failed to open trace output file'
!
END 	    ! fpt_open_rt_trace_file ******************************************
!
! *****************************************************************************
!
SUBROUTINE fpt_get_rt_trace_line
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
2010    CONTINUE
        READ (p_trace_input_lun,FMT = '(A)',END = 8010,ERR = 8020)                                                                 &
         c_trace_line
        IF (c_trace_line .EQ. ' ') THEN
           GOTO 2010
        ELSEIF (c_trace_line(1:1) .EQ. '!') THEN
           GOTO 2010
        ENDIF
!
        READ (c_trace_line(13:24),'(I12)')c_trace_sequence_number
        IF (c_trace_line(28:46) .EQ. 'Start sub-program: ') THEN
           c_trace_sp_name = c_trace_line(47:77)
        ELSEIF (c_trace_line(28:35) .EQ. 'Return: ') THEN
           c_trace_sp_name = c_trace_line(36:66)
        ELSE
           c_trace_equals = INDEX(c_trace_line,'=')+1
           IF (c_trace_equals .EQ. 1) THEN
              GOTO 8030
           ENDIF
        ENDIF
!
        RETURN
!
! *****************************************************************************
!
8010    CONTINUE
        STOP 'End of trace file'
!
8020    CONTINUE
        STOP '**** Error reading trace file ****'
!
8030    CONTINUE
        WRITE (6,'(A)')c_trace_line
        STOP '**** Unexpected format in trace file ****'
!
! *****************************************************************************
!
END 	    ! fpt_get_rt_trace_line *******************************************
!
! *****************************************************************************
!
SUBROUTINE fpt_rt_trace_sp_error(stra)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        CHARACTER*(*)stra
!
        INTEGER*4 lstra,lline
!
! *****************************************************************************
!
        lstra = LEN(stra)
        DO WHILE ((lstra .GT. 1) .AND.                                                                                             &
         (stra(lstra:lstra) .LE. ' '))
           lstra = lstra-1
        ENDDO
        lline = LEN(c_trace_line)
        DO WHILE ((lline .GT. 1) .AND.                                                                                             &
         (c_trace_line(lline:lline) .LE. ' '))
           lline = lline-1
        ENDDO
        WRITE (6,'(/,''**** Trace error at start of sub-program: '',A                                                              &
         & ,/,'' Trace file line: '',A)')                                                                                          &
         stra(1:lstra),c_trace_line(1:lline)
        WRITE (p_trace_lun                                                                                                         &
         ,'(/,''!*** Trace error at start of sub-program: '',A                                                                     &
         & ,/,''!Trace file line: '',A)')                                                                                          &
         stra(1:lstra),c_trace_line(1:lline)
!
        STOP '**** Error is fatal ****'
!
END 	    ! fpt_rt_trace_sp_error *******************************************
!
! *****************************************************************************
!
SUBROUTINE fpt_rt_trace_sequence_error(sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        INTEGER*4 sequa
!
        INTEGER*4 lline
!
! *****************************************************************************
!
        lline = LEN(c_trace_line)
        DO WHILE ((lline .GT. 1) .AND.                                                                                             &
         (c_trace_line(lline:lline) .LE. ' '))
           lline = lline-1
        ENDDO
        WRITE (6,'(/,''**** Trace sequence error: ''                                                                               &
         & ,/,'' Sequence number reached: '',I12                                                                                   &
         & ,/,'' Trace file line: '',A)')                                                                                          &
         sequa,c_trace_line(1:lline)
        WRITE (p_trace_lun,'(/,''!*** Trace sequence error: ''                                                                     &
         & ,/,''!Sequence number reached: '',I12                                                                                   &
         & ,/,''!Trace file line: '',A)')                                                                                          &
         sequa,c_trace_line(1:lline)
!
        STOP '**** Error is fatal ****'
!
END 	    ! fpt_rt_trace_sequence_error *************************************
!
! *****************************************************************************
!
SUBROUTINE fpt_rt_trace_value_error
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        INTEGER*4 lline,lvalue
!
! *****************************************************************************
!
        lline = LEN(c_trace_line)
        DO WHILE ((lline .GT. 1) .AND.                                                                                             &
         (c_trace_line(lline:lline) .LE. ' '))
           lline = lline-1
        ENDDO
        lvalue = LEN(c_trace_input)
        DO WHILE ((lvalue .GT. 1) .AND.                                                                                            &
         (c_trace_input(lvalue:lvalue) .LE. ' '))
           lvalue = lvalue-1
        ENDDO
        WRITE (6,'(/,''**** Trace value error: ''                                                                                  &
         & ,/,'' Value computed: '',A                                                                                              &
         & ,/,'' Trace file line: '',A)')                                                                                          &
         c_trace_input(1:lvalue),c_trace_line(1:lline)
        WRITE (p_trace_lun,'(/,''!*** Trace value error: ''                                                                        &
         & ,/,''!Value computed: '',A                                                                                              &
         & ,/,''!Trace file line: '',A)')                                                                                          &
         c_trace_input(1:lvalue),c_trace_line(1:lline)
!
        RETURN
!
END 	    ! fpt_rt_trace_value_error ****************************************
!
!
!
! *****************************************************************************
!
SUBROUTINE fpt_rt_trace_read_error
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        INTEGER*4 lline,lvalue
!
! *****************************************************************************
!
        lline = LEN(c_trace_line)
        DO WHILE ((lline .GT. 1) .AND.                                                                                             &
         (c_trace_line(lline:lline) .LE. ' '))
           lline = lline-1
        ENDDO
        lvalue = LEN(c_trace_input)
        DO WHILE ((lvalue .GT. 1) .AND.                                                                                            &
         (c_trace_input(lvalue:lvalue) .LE. ' '))
           lvalue = lvalue-1
        ENDDO
        WRITE (6,'(/,''**** Error reading trace file: ''                                                                           &
         & ,/,'' Value computed: '',A                                                                                              &
         & ,/,'' Trace file line: '',A)')                                                                                          &
         c_trace_input(1:lvalue),c_trace_line(1:lline)
        WRITE (p_trace_lun,'(/,''!*** Trace value error: ''                                                                        &
         & ,/,''!Value computed: '',A                                                                                              &
         & ,/,''!Trace file line: '',A)')                                                                                          &
         c_trace_input(1:lvalue),c_trace_line(1:lline)
!
        RETURN
!
END 	    ! fpt_rt_trace_read_error *****************************************
!
!
! *****************************************************************************
!
SUBROUTINE fpt_rt_trace_controls
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
        INTEGER*4 i,j
!
! *****************************************************************************
!
        OPEN (UNIT = p_trace_input_lun,FILE = 'trace_controls.txt'                                                                 &
         ,STATUS = 'OLD',ERR = 9900)
!
1000    CONTINUE
        READ (p_trace_input_lun,'(A)',ERR = 9010,END = 9910)c_trace_line
        IF ((c_trace_line .EQ. ' ') .OR.                                                                                           &
         (c_trace_line(1:1) .EQ. '!')) THEN
           GOTO 1000
        ELSEIF (c_trace_line(1:10) .EQ. 'REAL DELTA') THEN
           c_trace_equals = INDEX(c_trace_line,'=')+1
           READ (c_trace_line(c_trace_equals:c_trace_equals+23),'(E12.6)'                                                          &
            ,ERR = 9010)c_real_delta
        ELSEIF (c_trace_line(1:10) .EQ. 'REAL RATIO') THEN
           c_trace_equals = INDEX(c_trace_line,'=')+1
           READ (c_trace_line(c_trace_equals:c_trace_equals+23),'(E12.6)'                                                          &
            ,ERR = 9010)c_real_ratio
        ELSEIF (c_trace_line(1:15) .EQ. 'TRACE DIRECTORY') THEN
           c_trace_equals = INDEX(c_trace_line,'=')+1
           i = c_trace_equals
           DO WHILE ((c_trace_line(i:i) .LE. ' ') .AND.                                                                            &
            (i .LT. LEN(c_trace_line)))
              i = i+1
           ENDDO
           j = LEN(c_trace_line)
           DO WHILE (c_trace_line(j:j) .LE. ' ')
              j = j-1
           ENDDO
           IF (j .GT. i) THEN
              c_trace_directory = c_trace_line(i:j)
              c_directory_length = j-i+1
           ENDIF
        ELSEIF (c_trace_line(1:18) .EQ. 'OVERWRITE INTEGERS') THEN
           c_overwrite_integers_f = .TRUE.
        ELSEIF (c_trace_line(1:25) .EQ. 'DO NOT OVERWRITE INTEGERS') THEN
           c_overwrite_integers_f = .FALSE.
        ELSEIF (c_trace_line(1:18) .EQ. 'OVERWRITE LOGICALS') THEN
           c_overwrite_integers_f = .TRUE.
        ELSEIF (c_trace_line(1:25) .EQ. 'DO NOT OVERWRITE LOGICALS') THEN
           c_overwrite_integers_f = .FALSE.
        ELSE
           GOTO 9010
        ENDIF
        GOTO 1000
!
9010    CONTINUE
        STOP '**** Error in trace_controls.txt ****'
!
9900    CONTINUE
        WRITE (6,'("!*** trace_controls.txt not found, using defaults")')
9910    CONTINUE
        CLOSE (p_trace_input_lun)
        RETURN
!
END 	    ! fpt_rt_trace_controls *******************************************
