!H!****************************************************************************
!H! File: ../fpt_output/WRFV3/external/fpt_lib/trace_i8_data.f90
!H! Output by FPT 3.7-u Intel-Linux   On  9-JUN-13  At 15:47:57    Input files:
!H! Main:    ...pt2/WRF/WRFV3.3/compiler_validation/fpt/WRFV3.3_raw_raw_rtt.fpp
!H! Current: /usr/local/fpt/fpt37/fpt_lib/trace_i8_data.for
!H! Licensee:  SimCon: Development version.
!H!****************************************************************************
! *****************************************************************************
! trace_i8_data.for		23-Feb-06			John Collins
!				26-Oct-06			John Collins
!
! Note that this routine is separated from rt_trace.for because INTEGER*8
! is not supported on all platforms
!
! *****************************************************************************
! 23-Feb-06 John Collins  First use
! 24-Aug-12 John Collins  Trace data suppressed in check mode
! 26-Oct-12 John Collins  Option to suppress overwriting.  Read error handling
! *****************************************************************************
!
SUBROUTINE trace_i8_data(stra,i8a,sequa)
!
        IMPLICIT NONE
!
! *****************************************************************************
!
        INCLUDE 'rt_trace.inc'
!
! *****************************************************************************
!
!	Arguments
!	=========
!
        CHARACTER*(*)stra		! String describing object written
        INTEGER*8 i8a			!
        INTEGER*4 sequa
!
!       Locals
!       ======
!
        CHARACTER*50 str
        CHARACTER*24 sequs
        CHARACTER*20 i8s
        INTEGER*8 i8
!
! *****************************************************************************
!
        str = stra
!
        IF (.NOT. trace_file_open_flag) THEN
           CALL fpt_open_rt_trace_file
           trace_file_open_flag = .TRUE.
        ENDIF
!
        IF (trace_active_flag) THEN
           IF (c_rt_trace_check_f) THEN
              CALL fpt_get_rt_trace_line
              IF (sequa .NE. c_trace_sequence_number) THEN
                 CALL fpt_rt_trace_sequence_error(sequa)
              ENDIF
              READ (c_trace_line(c_trace_equals:),'(I20)',ERR = 1010)i8
              GOTO 1020
1010          CONTINUE
              WRITE (c_trace_input,'(I20)')i8a
              CALL fpt_rt_trace_read_error
              i8 = i8a
1020          CONTINUE
              IF (i8 .NE. i8a) THEN
                 WRITE (c_trace_input,'(I20)')i8a
                 CALL fpt_rt_trace_value_error
                 IF (c_overwrite_integers_f) THEN
                    i8a = i8
                 ENDIF
              ENDIF
           ELSE
              WRITE (sequs,'(2I12)')c_trace_event,sequa
              WRITE (i8s,'(I20)')i8a
              WRITE (p_trace_lun,'(5A)')sequs,'   ',str,'=',i8s
           ENDIF
        ENDIF
!
        RETURN
!
END 	    ! trace_i8_data ***************************************************
