#!/bin/csh -f

echo "copy_wrf_files.csh"
echo " "

set nonomatch

if (! -e $2) then
	echo "This script must be run from the parent directory containing"
	echo "$2 and $3.  Aborting"
	echo " "
	exit
endif

if ($4 != 's') then
	echo "Usage:  copy_wrf_files.csh <type> <from_directory> <to_directory> [s]"
	echo "   Directories specified are the parents of a WRFV3 directory structure"
	echo "e.g.    copy_wrf_files.csh *.F ./fpt_output ./build_directory"
	echo "The optional 4th argument 's' runs silently, without prompting"
	echo " "
	echo -n "Do you wish to continue? [y|n]: "
	set REQ = $<
	if (($REQ != 'y') && ($REQ != 'Y')) then
		echo "Aborted"
		exit
	endif

	echo "Continuing"
	echo " "
endif

foreach d ( arch dyn_em dyn_exp dyn_nmm frame inc main phys share tools external \
            external/atm_ocn external/esmf_time_f90 external/fftpack/fftpack5 external/ioapi_share \
            external/io_esmf external/io_grib1 external/io_grib1/build external/io_grib1/grib1_util \
            external/io_grib1/MEL_grib1 external/io_grib1/WGRIB external/io_grib2 \
            external/io_grib2/bacio-1.3 external/io_grib2/g2lib external/io_grib2/g2lib/utest \
            external/io_grib_share external/io_grib_share/build external/io_int external/io_mcel \
            external/io_netcdf external/io_phdf5 external/io_pnetcdf external/RSL_LITE external/fpt_lib )

	if ( -e $2/WRFV3/$d ) then
		if ( -e $3/WRFV3/$d ) then
			cp -f $2/WRFV3/$d/$1 $3/WRFV3/$d/ >& /dev/null
	    	else
	        	echo "$3/WRFV3/$d does not exist"
	    	endif
	else
		echo "$2/WRFV3/$d does not exist"
	endif
end

echo " "
echo "copy_wrf_files.csh"

# End








